//==============================================================================
//       
//==============================================================================
#include "stm32f10x.h"
#include "macros.h"
#include "calendar.h"

#include <stdio.h>
void putstr(unsigned char numstr, char *str);

extern const uint8_t month_day[];// =
const uint16_t month_days1[12] =
    {0,31,59,90,120,151,181,212,243,273,304,334};//,365};
const uint16_t month_days2[12] =
    {0,31,60,91,121,152,182,213,244,274,305,335}; //,366};
//-----------------------------------------------------------------------------
uint32_t calendar_codr(calendar_type * calendar)
{ uint32_t tmp = 0;
  uint8_t i;
//  ,   01.01.2000  
  for (i = 0; i < calendar->year; i++)
  { tmp += 365;
    if ((i % 4) == 0) tmp++;
  }  
//       
  for (i = 0; i < calendar->month - 1; i++) tmp += month_day[i];
//    
  if ((calendar->month > 2) & ((calendar->year % 4) == 0)) tmp++;
  tmp += calendar->day; 
  tmp *= 86400;
  tmp += calendar->hour * 3600;
  tmp += calendar->minutes * 60;
  tmp += calendar->seconds;
  return tmp;
}
//==============================================================================
void calendar_decodr(uint32_t value, calendar_type * calendar)
{ uint16_t days = value / 86400; //    01.01.2000
  uint32_t hms = value % 86400;  //  = 
//------------------------------------------------------------------------------
  calendar->day_of_the_week = ((days - 3) % 7) + 2;
  uint16_t ndays[10] =    //    1 
  { 4383,   // 01.01.2012
    4749,   // 01.01.2013
    5114,   // 01.01.2014
    5479,   // 01.01.2015
    5844,   // 01.01.2016
    6209,   // 01.01.2017
    6574,   // 01.01.2018
    6939,   // 01.01.2019
    7304,   // 01.01.2020
    7994    // 01.01.2021
   };
  uint8_t c, myear;    //   - 12
  for (c = 9; c > 0; c--)
  {
      if (days > ndays[c]) break;
  }  
  myear = c;    //   - 12
  calendar->year  = myear + 12;
  uint16_t day_in_year = days - ndays[myear];

  if ((calendar->year % 4) == 0)
  { for (c = 11; c > 0; c--)
    { if (day_in_year > month_days2[c]) break;
    }
  }
  else
  { for (c = 11; c > 0; c--)
    { if (day_in_year > month_days1[c]) break;
    }
  } 
//  uint8_t mmonth = c + 1;
  calendar->month = c + 1;
//  uint8_t day_of_month = days - month_days2[mmonth];
  calendar->day = days - month_days2[calendar->month];
//------------------------------------------------------------------------------
  uint16_t tmp;
  calendar->hour = hms / 3600; // 
  tmp = hms % 3600;  // 
  calendar->minutes = tmp / 60;
  calendar->seconds = tmp % 60;
//  sprintf(s,"%6d-%02d:%02d:%02d-%04d",hms,c1,c3,c4,c2); putstr(4,s);
}
//==============================================================================
