//==============================================================================
#include "stm32f10x.h"
void _delay_us(unsigned int _val);
void _delay_ms(unsigned int _val);
unsigned int d = 0;

static const char perecod[64] = { 
	'A' , 0xA0, 'B' , 0xA1, 0xE0, 'E' , 0xA3, 0xA4,
        0xA5, 0xA6, 'K' , 0xA7, 'M' , 'H' , 'O' , 0xA8, 
	'P' , 'C' , 'T' , 0xA9, 0xAA, 'X' , 0xE1, 0xAB, 
        0xAC, 0xE2, 0xAD, 0xAE, 'b' , 0xAF, 0xB0, 0xB1, 
	'a' , 0xB2, 0xB3, 0xB4, 0xE3, 'e' , 0xB6, 0xB7, 
        0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 'o' , 0xBE, 
	'p' , 'c' , 0xBF, 'y' , 0xE4, 'x' , 0xE5, 0xC0, 
        0xC1, 0xE6, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7 }; 
const uint8_t lcdaddr[4] = {0x02, 0xC0, 0x94, 0xD4};
//==============================================================================
void lcdcmd8(uint8_t cmd)
{ GPIOA->BSRR = GPIO_BSRR_BR4 | GPIO_BSRR_BR5 | GPIO_BSRR_BR6 | GPIO_BSRR_BR7;
  GPIOA->ODR |= (cmd & 0xF0);
  GPIOA->BSRR = GPIO_BSRR_BS2;
  _delay_us(300);
  GPIOA->BSRR = GPIO_BSRR_BR2;
  _delay_us(300);
}
//==============================================================================
void lcdcmd(uint8_t cmd)
{ lcdcmd8(cmd);
  lcdcmd8(cmd<<4);
}
//==============================================================================
void lcddata(uint8_t sym)
{ if(sym >= 0xC0) sym = perecod[sym - 0xC0]; 
  else
  { if(sym >= 0x80) sym += 0x40; 
  }
  GPIOA->BSRR = GPIO_BSRR_BS3;
  lcdcmd8(sym);
  lcdcmd8(sym<<4);
  GPIOA->BSRR = GPIO_BSRR_BR3;
  _delay_us(300);
}
//------------------------------------------------------------------------------
void clearlcd(void)
{ lcdcmd(0x01);
  _delay_us(300);
}
//==============================================================================
//     1     
//    
//-------------------------------------------------------------------------------------------------------------------
void putstr(uint8_t numstr, char *str)
{ uint8_t c = 0;
  lcdcmd(lcdaddr[numstr - 1]);    
  _delay_ms(3);
  while(*str != 0)
  { lcddata(*str++);
    c++;
  }    
  while(1)
  { if (c > 8) break;
    lcddata(' ');
    c++;
  }      
  _delay_ms(3);
}
//==============================================================================
void lcd_init(void)
{ lcdcmd8(0x30);  // 8- 
  lcdcmd8(0x30);
  lcdcmd8(0x30);
  _delay_ms(40);
  lcdcmd8(0x20);   // 4- 
  lcdcmd(0x2A);
  lcdcmd(0x0C);
  lcdcmd(0x06);
  clearlcd();
}
//==============================================================================
