// IAR Embedded Workbench for ARM, Evaluation license  6.21
//       CSTACK 0x800
// 28  2013.
//==============================================================================
#include "stm32f10x.h"
#include <stdio.h>
#include "ff.h"
#include "diskio.h"
#include "fattime.h"
#include "integer.h"
#define keyOFF  0x03A0
#define keyF0   0x01A0
#define keyF1   0x02A0
#define keyF2   0x0320
#define keyF3   0x0380

unsigned char regime = 1;   //     
#define _REGIM1     1       //  
#define _REGIM2     2       //   
#define _MAXREGIME  2       //  -1

char s[9];

void init(void);
void putstr(unsigned char numstr, char *str);

volatile uint8_t __flag_rtc = 0;  //   RTC
unsigned int _keypressed = 0xFFFF;

typedef struct
{ uint8_t day;
  uint8_t hour;
  uint8_t minutes;
  uint8_t seconds;
} calendar_type;
calendar_type calendar;
//==============================================================================
uint32_t readcalendar()
{ uint32_t retval = (uint32_t)(RTC->CNTH);
  retval <<= 16; 
  retval += RTC->CNTL;
  return retval;
}
//==============================================================================
void _delay_us(uint16_t _val)
{ for(; _val != 0; _val--)
  { __no_operation();
    __NOP();
  }
}
//==============================================================================
void _delay_ms(uint16_t _val)
{ uint16_t _cikles = 6000;
  for (; _cikles > 0; _cikles--)
  { _delay_us(_val);
  }  
}
//==============================================================================
void mexecute(
  uint8_t variant,  // -     
  uint8_t dow,      //  
  uint8_t mhour, 
  uint8_t mminut, 
  uint8_t mexanism, //  
  char execute)
{ 
  if ((variant != 'N') && (variant != 'W'))     return;
  if ((variant == 'W') && (calendar.day != (dow - '0')))  return;    
  if ((calendar.hour == mhour) && (calendar.minutes == mminut))
  { if (execute == 'U')
    { switch(mexanism)
      { case 1:  
          GPIOB->BSRR = GPIO_BSRR_BS0;
          break;
        case 2:  
          GPIOB->BSRR = GPIO_BSRR_BS1;
          break;
        case 3:  
          GPIOB->BSRR = GPIO_BSRR_BS10;
          break;
        case 4:  
          GPIOB->BSRR = GPIO_BSRR_BS3;
          break;
        case 5:  
          GPIOB->BSRR = GPIO_BSRR_BS4;
          break;
        case 6:  
          GPIOB->BSRR = GPIO_BSRR_BS6;
          break;
        case 7:  
          GPIOA->BSRR = GPIO_BSRR_BS8;
          break;
        case 8:  
          GPIOA->BSRR = GPIO_BSRR_BS9;
          break;
      }
      _delay_ms(800);
    }
    else if (execute == 'D')
    { switch(mexanism)
      { case 1:  
          GPIOB->BSRR = GPIO_BSRR_BR0;
          break;
        case 2:  
          GPIOB->BSRR = GPIO_BSRR_BR1;
          break;
        case 3:  
          GPIOB->BSRR = GPIO_BSRR_BR10;
          break;
        case 4:  
          GPIOB->BSRR = GPIO_BSRR_BR3;
          break;
        case 5:  
          GPIOB->BSRR = GPIO_BSRR_BR4;
          break;
        case 6:  
          GPIOB->BSRR = GPIO_BSRR_BR6;
          break;
        case 7:  
          GPIOA->BSRR = GPIO_BSRR_BR8;
          break;
        case 8:  
          GPIOA->BSRR = GPIO_BSRR_BR9;
          break;
      }
      _delay_ms(800);
    }
  }
}
//==============================================================================
//   
//------------------------------------------------------------------------------
FRESULT read_file()
{ FRESULT retval;
  FIL file;           //  
  char s1[20];        //  
  unsigned int bw;
  FATFS   fs;        
  disk_initialize(0);
  f_mount(0, &fs);
//-----------------------------------------
  retval = f_open(&file,"0:homectrl.txt",FA_OPEN_EXISTING | FA_READ);
  if(retval) return retval;
  while(1)
  { retval = f_read (&file,s,1,&bw);
    if (bw < 1) break;           
    s[1] = 0;
    if (s[0] == '#')                  //   , 
    { retval = f_read (&file,s1,11,&bw); //   
      s1[11] = 0;                     //    
      mexecute(                       //  
        s1[0],                        //  'N'  'W'
        s1[1],                        // 
        (s1[3]-'0')*10 + (s1[4]-'0'), // 
        (s1[5]-'0')*10 + (s1[6]-'0'), // 
        (s1[8]-'0'),                  //  
        s1[10]);                      //  
    }    
  }
  retval = f_close(&file);
  f_mount(0, NULL);
  return retval; 
}
//==============================================================================
uint32_t calendar_coder(calendar_type * calendar)
{ uint32_t tmp = calendar->day * 86400;
  tmp += calendar->hour * 3600;
  tmp += calendar->minutes * 60;
  tmp += calendar->seconds;
  return tmp;
}
//==============================================================================
void calendar_decoder(uint32_t value, calendar_type * calendar)
{ calendar->day = value / 86400; //    01.00.00
  uint32_t hms  = value % 86400;  //  = 
  uint16_t tmp;
  calendar->hour = hms / 3600; // 
  tmp = hms % 3600;  // 
  calendar->minutes = tmp / 60;
  calendar->seconds = tmp % 60;
}
//==============================================================================
void __set_datatime(uint8_t variant)
{ uint32_t val = readcalendar();
  calendar_decoder(val, &calendar);
  switch(variant)
  { case 1:   //  
      calendar.seconds = 0;
      break;
    case 2:   //  
      if (calendar.minutes >= 58) calendar.minutes = 0;
      else calendar.minutes++;
      break;
    case 3:   //  
      if (calendar.hour >= 22) calendar.hour = 0;
      else calendar.hour++;
      break;
    case 4:   //   
      if (calendar.day >= 7) calendar.day = 1;
      else calendar.day++;
      break;
  }  
  val = calendar_coder(&calendar);
  RTC->CRL |= RTC_CRL_CNF;
  RTC->CNTH = val >> 16;  
  RTC->CNTL = val;        
  RTC->CRL &= ~RTC_CRL_CNF;
}
//==============================================================================
//   ,     
void remont_data(void)
{ uint32_t val = readcalendar();
  calendar_decoder(val, &calendar);
  if ((calendar.day < 1) || (calendar.day > 7)) calendar.day = 1;
  val = calendar_coder(&calendar);
  RTC->CRL |= RTC_CRL_CNF;
  RTC->CNTH = val >> 16;  
  RTC->CNTL = val;        
  RTC->CRL &= ~RTC_CRL_CNF;
}
//==============================================================================
void main(void)
{ uint32_t val;
  char *DayOfWeek[7] = {".","","","","","","."};
  uint8_t _retR1 = 0;   //     1   
  init();
  remont_data();  
  while (1)
  { switch(regime)
      { case _REGIM1: //     
          sprintf(s,"%02d:%02d:%02d",calendar.hour,calendar.minutes,calendar.seconds);
          putstr(1,s);  
          sprintf(s," %s",DayOfWeek[(calendar.day - 1) % 7]);
          putstr(2,s);
          break;
        case _REGIM2: //     
          sprintf(s,"%s",DayOfWeek[(calendar.day - 1) % 7]);
          putstr(1,s);
          putstr(2," .");
          break;
      }    
////////////////////////////////////////////////////////////////////////////////
    _keypressed = GPIOB->IDR & 0x03A0;
    if (_keypressed != 0x03A0)
    { _delay_ms(50);
      _retR1 = 0;
      _keypressed = GPIOB->IDR & 0x03A0;
      switch(_keypressed)
      { case keyF0:
          regime++;
          if (regime > _MAXREGIME) regime = 1;
          break;
        case keyF1:
          switch(regime)
          { case _REGIM1:
              __set_datatime(3);
              break;
          }  
          break;
        case keyF2:
          switch(regime)
          { case _REGIM1:
              __set_datatime(2);
              break;
          }  
          break;
      case keyF3:
          switch(regime)
          { case _REGIM1:
              __set_datatime(1);
              break;
            case _REGIM2:
              __set_datatime(4);
              break;
          }          
          break;
      }
      _keypressed = 0xFFFF;
    }  
////////////////////////////////////////////////////////////////////////////////
    if(__flag_rtc == 1)             //   RTC
    { __flag_rtc = 0;
      GPIOB->BSRR = GPIO_BSRR_BS11; //   
      val = readcalendar();
      calendar_decoder(val,&calendar);
      if (calendar.seconds == 2)    //  2 ...
      { putstr(2,"!!!");
        read_file();
        _retR1++;
        if (_retR1 > 3)             //  4 
          regime = 1;               //   1
      } 
    }
    _delay_ms(50);
    GPIOB->BSRR = GPIO_BSRR_BR11;   //   
  }
} // main
//==============================================================================
// ,  RTC
//==============================================================================
void RTC_IRQHandler(void)
{ if(RTC->CRL & RTC_CRL_SECF)
  { RTC->CRL &= ~RTC_CRL_SECF; 
    __flag_rtc = 1;             //   RTC
  }
}
//==============================================================================
