//==============================================================================
//     RTC
// #_07.10.2012
//------------------------------------------------------------------------------
//#include "svech.h"
#include "stm32f10x.h"
#include "clock.h"

extern uint32_t val;
extern uint8_t chasov, minut, secund;
extern uint8_t __flag_rtc;  //   RTC
//-----------------------------------------------------------------------------
uint32_t clock_coder(clock_type * clock)
{ uint32_t tmp;
  tmp = clock->hour * 3600;
  tmp += clock->minutes * 60;
  return tmp + clock->seconds;
}
//-----------------------------------------------------------------------------
void clock_decoder(uint32_t value, clock_type * clock)
{ clock->hour = (value / 3600) % 24;
  clock->minutes = (value % 3600) / 60;
  clock->seconds = (value % 3600) % 60;
}
//==============================================================================
//  
// #_06.10.2012
//------------------------------------------------------------------------------
void _settime()
{ 
  val = (uint32_t)0 + (chasov*3600) + (minut*60) +  secund;
  RTC->CRL |= RTC_CRL_CNF;  //     
  RTC->CNTL = val;
  RTC->CNTH = val>>16;  
  RTC->CRL &= ~RTC_CRL_CNF; //   
}
//********************************************************************************************
//function       RTC
// http://mycontroller.ru/stm32-rtc-initsializatsiya-i-ispolzovanie 
// #_25.06.2012
//********************************************************************************************
void RTC_SetCounter(uint32_t value)
{
  RTC->CRL |= RTC_CRL_CNF;    //  
  RTC->CNTH = value>>16;      //    
  RTC->CNTL = value;          //
  RTC->CRL &= ~RTC_CRL_CNF;   //   
}
//   ,  
/*void _settime()
{ val = (uint32_t)0 + (chasov*3600) + (minut*60) +  secund;
  RTC->CRL |= RTC_CRL_CNF;  //     
  RTC->CNTL = val;
  RTC->CNTH = val>>16;  
  RTC->CRL &= ~RTC_CRL_CNF; //   
}*/
//==============================================================================
void mcu_rtc_init(void)
{ uint32_t rtc_value;

  clock_type clock;
  clock.hour = 20;  
  clock.minutes = 43;  
  clock.seconds = 0;  
  rtc_value = clock_coder(&clock);
//RTC_SetCounter(rtc_value);
  
  RCC->APB1ENR |= RCC_APB1ENR_PWREN | RCC_APB1ENR_BKPEN;
//Bit 28 PWREN: Power interface clock enable. Set and cleared by software. 
//0: Power interface clock disabled, 1: Power interface clock enable 
//Bit 27 BKPEN: Backup interface clock enable. Set and cleared by software. 
//0: Backup interface clock disabled, 1: Backup interface clock enabled 
  
  PWR->CR |= PWR_CR_DBP;

//  char s[18];
//  sprintf(s," %08X",RCC->BDCR);     // 0x00008103
//  sprintf(s," %08X",RCC_BDCR_RTCEN);  // 0x00008000
//  home(); showstr(s);

//BackupControlDomainRegister   
//RCC_BDCR_RTCEN  RTC ClockEnable
// ,   ,     
  if ((RCC->BDCR & RCC_BDCR_RTCEN) != RCC_BDCR_RTCEN)
  { RCC->BDCR |= RCC_BDCR_BDRST;
    RCC->BDCR &= ~RCC_BDCR_BDRST;
    RCC->BDCR |= RCC_BDCR_RTCEN | RCC_BDCR_RTCSEL_LSE;
    RTC->CRL |= RTC_CRL_CNF;
    RTC->PRLL = 0x7FFF;
    RTC->CNTH = rtc_value >> 16;
    RTC->CNTL = rtc_value;
    RTC->CRL &= ~RTC_CRL_CNF;
    RCC->BDCR |= RCC_BDCR_LSEON;
    while ((RCC->BDCR & RCC_BDCR_LSEON) != RCC_BDCR_LSEON)
    {
    }
    RTC->CRL &= (uint16_t)~RTC_CRL_RSF;
    while((RTC->CRL & RTC_CRL_RSF) != RTC_CRL_RSF)
    {
    }
  }
//******************************************************************************
//      RTC
//******************************************************************************  
// 2.    RTC,    :
  RTC->CRL |=  RTC_CRL_CNF;   //    RTC
  RTC->CRH  =  RTC_CRH_SECIE; //     
//RTC->CRH  =  RTC_CRH_ALRIE; //       
                              //  
//RTC->CRH  =  RTC_CRH_OWIE;  //     
                              //  
  RTC->CRL &= ~RTC_CRL_CNF;   //   
// 3.     RTC:
//******************************************************************************  
  NVIC_EnableIRQ (RTC_IRQn);  //  , 
}
//********************************************************************************************
//function  RTC                                                                //
//argument none                                                                             //
//result   1 -  ; 0 -                      //
//********************************************************************************************
unsigned char  RtcInit  (void)
{
 //        
  RCC->APB1ENR |= RCC_APB1ENR_PWREN | RCC_APB1ENR_BKPEN;
  //     
  PWR->CR |= PWR_CR_DBP;
  //   -  
  if ((RCC->BDCR & RCC_BDCR_RTCEN) != RCC_BDCR_RTCEN)
  {
    //    
    RCC->BDCR |=  RCC_BDCR_BDRST;
    RCC->BDCR &= ~RCC_BDCR_BDRST;
 
    //      32768   
    RCC->BDCR |=  RCC_BDCR_RTCEN | RCC_BDCR_RTCSEL_LSE;
 
    RTC->CRL  |=  RTC_CRL_CNF;
    RTC->PRLL  = 0x7FFF;         //   32768
    RTC->CRL  &=  ~RTC_CRL_CNF;
 
    //        
    RCC->BDCR |= RCC_BDCR_LSEON;
    while ((RCC->BDCR & RCC_BDCR_LSEON) != RCC_BDCR_LSEON){}
 
    RTC->CRL &= (uint16_t)~RTC_CRL_RSF;
    while((RTC->CRL & RTC_CRL_RSF) != RTC_CRL_RSF){}
    return 1;
  }
  return 0;
}
//==============================================================================
//   RTC
// http://mycontroller.ru/stm32-rtc-initsializatsiya-i-ispolzovanie 
// #_25.06.2012
//********************************************************************************************
uint32_t RTC_GetCounter(void)
{ return  (uint32_t)((RTC->CNTH << 16) | RTC->CNTL);
}
//==============================================================================
// ,  RTC
//==============================================================================
void RTC_IRQHandler(void)
{ 
//  -    ( )
  if(RTC->CRL & RTC_CRL_SECF)
  { RTC->CRL &= ~RTC_CRL_SECF; 
    __flag_rtc = 1;             //   RTC
  }
}
//==============================================================================
